Subject: FW: Regarding cost based algorithm for finding Extended P-Space.

From: Bharath R <[email-masked]>
Date: Fri, 3 Jan 2014 18:20:17 +0000

Just wanted to make explicit that the loop-causing neighbor packets reaching out a loop-causing neighbor A2, would eventually exit out of one of the non-loop causing viable Neighbor A1.
So, could there still be a practical use-case for choosing A2 over A1?

Thanks and Regards,
Bharath R.

From: Bharath R
Sent: Friday, January 03, 2014 11:39 PM
To: [email-masked]'; [email-masked]; [email-masked]; [email-masked]; [email-masked]; [email-masked]; [email-masked]
Subject: RE: Regarding cost based algorithm for finding Extended P-Space.

Hi Stewart,
Thanks for your inputs.
Yes, this formula does not cover the Node-protecting P-Space, for which the formulae specified in
https://ietf.org/doc/draft-psarkar-rtgwg-rlfa-node-protection/

Thanks for your offer of running this by Mike. Hoping to hear from that.

Also, I would like one more input, if you may:
Do you think there would be some practical use-case for preferring A2(loop causing neighbor) as the backup-neighbor over A1(non loop-causing Neighbor)?

Thanks and Regards,
Bharath R.
From: Stewart Bryant [mailto:[email-masked]]
Sent: Friday, January 03, 2014 11:27 PM
To: Bharath R; [email-masked]<mailto:[email-masked]>; [email-masked]<mailto:[email-masked]>; [email-masked]<mailto:[email-masked]>; [email-masked]<mailto:[email-masked]>; [email-masked]<mailto:[email-masked]>; [email-masked]<mailto:[email-masked]>
Subject: Re: Regarding cost based algorithm for finding Extended P-Space.

Bharath

I will run this past Mike when he gets back next week, but I think you are
correct. Note that this simplification will not work when we come to node
protection since you must look at alternative paths through the nodes, but
for link protection, I think you are correct to state that avoiding the repairing
node is sufficient.

Thanks for picking this up.

- Stewart

On 03/01/2014 17:29, Bharath R wrote:
Hi Stewart,
The point here is not about the P-Space, but the eligible Backup-Neighbor to reach P-Space.
In the below topology, the P-Space remains unchanged, but we have two possible backup-neighbors:
A1, which does not have looping problems
A2, which loops back the traffic to S, and then has it going via A1, before reaching the  other P-Space nodes and eventually the PQ node.
But, with application of formula 2), we will have only A1 as the viable backup Neighbor.

And regarding the second formula ensuring that the packet does not take the failed link(The SE link):

To re-quote the formulae:
1). D_opt(Ni, Y) < (D_opt(Ni, S) + D_opt(S, Protected_link.RemoteNode) + D_opt(Protected_link.RemoteNode, Y))
2). D_opt(Ni, Y) < (D_opt(Ni, S) + D_opt(S, Y))

Since formula 2). ensures that the packet does not reach S itself, the question of taking the SE link does not arise.
In fact, the formula 2) gives a 'non-loopingback' subset of neighbors as compared to formula 1).

Furthermore, existence of a Neighbor(Ni) satisfying Formula 1), but not satisfying formula 2), should imply existence of some other Neighbor(Nj) satisfying formula 2).
Because eventually Ni will loopback the traffic via Nj.
So, we will not miss out on finding a viable neighbor if one exists.

Please let me know if there is any gap in my understanding/analysis.

Thanks and regards,
Bharath R.

From: Stewart Bryant [mailto:[email-masked]]
Sent: Friday, January 03, 2014 10:34 PM
To: Bharath R; [email-masked]<mailto:[email-masked]>; [email-masked]<mailto:[email-masked]>; [email-masked]<mailto:[email-masked]>; [email-masked]<mailto:[email-masked]>; [email-masked]<mailto:[email-masked]>; [email-masked]<mailto:[email-masked]>
Subject: Re: Regarding cost based algorithm for finding Extended P-Space.

The purpose of the two protected link terms was to
make sure that there was no attempt to reach PQ via
that link. If we remove them we need to make sure
that no topology will cause that path to be taken,
and I think that your equation could fail on that
account.

I need to think about this some more, but
even if A2 is in P space, it is not in D's
Qspace so surely the point is moot?

- Stewart

On 03/01/2014 14:40, Bharath R wrote:
Thank you for your reply Stuart

Sorry, the formula is not verbatim from the draft, but if you refer to the formula in
Compute_Extended_P_Space()snippet
in the http://tools.ietf.org/html/draft-ietf-rtgwg-remote-lfa-04,

you will find that the formula used maps to
D_opt(Ni, Y) < (D_opt(Ni, S) + D_opt(S, Protected_link.RemoteNode) + D_opt(Protected_link.RemoteNode, Y))
Here:
S : Source Node.
Ni:  Neighbor,
D_opt(x, y): Optimal distance from x to y.

Sorry for the corruption in topology. I am recreating it here:
and A2-->S cost is 5; (Only in the direction as indicated., the other direction cost is unity)
All other costs are unity.

                                                                  |-------------|
                                                                  |        S       |
                                                                  |-------------|
                                                                   |      |       |
                                                                   |      |       |ProtectedLink
                                                                   |      |       |
                                                                   |      |       |
                                                  ---------------     |      ----------------
                                                  |                       |                          |
                                                  |                       |                          |
                                                  |                       |                          |
                                                  |                       |5                        |
                                            |-----------|         |-----------|        |-----------|
                                            |     A1    |          |    A2     |        |     E       |
                                            |-----------|         |-----------|        |-----------|
                                                  |                                                   |
                                                  |                                                   |
                                                  |                                                   |
                                            |-----------|                               |-----------|
                                            |     B       |                                |     D      |
                                            |-----------|                                |-----------|
                                                  |                                                  |
                                                  |                                                  |
                                                  |                  |-----------|              |
                                                  |--------------|     C      |-----------|
                                                                      |-----------|

Yes, even I am not sure of the practicality of the above topology,
But, my only point was that we have a simpler,
easier to use formula:
D_opt(Ni, Y) < (D_opt(Ni, S) + D_opt(S, Y))
to find viable backups Neighbors to reach P-Space.
Further, the formula does not result in exclusion of any viable Neighbor that loop-back to the source.

Would be great if you can comment on that.

Thanks and Regards,
Bharath R.

From: Stewart Bryant [mailto:[email-masked]]
Sent: Friday, January 03, 2014 7:27 PM
To: Bharath R; [email-masked]<mailto:[email-masked]>; [email-masked]<mailto:[email-masked]>; [email-masked]<mailto:[email-masked]>; [email-masked]<mailto:[email-masked]>; [email-masked]<mailto:[email-masked]>; [email-masked]<mailto:[email-masked]>
Subject: Re: Regarding cost based algorithm for finding Extended P-Space.

On 03/01/2014 11:35, Bharath R wrote:
Hi,
I have a query on cost based formula for finding Extended P-space.
The current formula applies to Node y that is
1). D_opt(Ni, Y) < (D_opt(Ni, S) + D_opt(S, Protected_link.RemoteNode) + D_opt(Protected_link.RemoteNode, Y))

Bharath

I cannot see this text in the draft. Is it from the text or your code?

Also the example below has been corrupted.

Not that asymmetric costs are always problematic in LFA solutions, but
it is not clear how frequently they show in real topologies other than
by accident.

Stewart

I guess the rationale behind the current formula is that the packet on the LDP tunnel should not traverse the ProtectedLink.

But, please consider the following toplogy.
A2-->B cost is 5 and A2-->S cost is 3; (Both only in the direction as indicated., the other direction cost is unity)
All other costs are unity.
Following the formula, both A1 and A2 can become backup neighbors(with P-Space B and C).
However, an LDP tunnel setup via A2 will loopback to S, taking A2-->S-->A1 path.

                                                                 |-------------|
                                                                  |     S       |
                                                                  |-------------|
                                                                    |      |      |
                                                                   |      |      |
                                                                    |      |      |ProtectedLink
                                                                   |      |      |
                                                                    |      |      |
                                                 |      |      |
                                                  ---------------      |      ----------------
                                                  |                       |                          |
                                                  |                       |                          |
                                                  |                       |                          |
                                                  |                       |                          |
                                                  |                        |5                        |
                                            |-----------|         |-----------|        |-----------|
                                            |     A1   |         |    A2     |        |     E       |
                                            |-----------|         |-----------|        |-----------|
                                                  |                                                   |
                                                  |                                                |
                                                  |                                                    |
                                                  |                                                   |
                                                  |                                                   |
                               |-----------|                          |-----------|
                                            |     B       |                                |     D    |
                                            |-----------|                                |-----------|
                                                  |                                                  |
                                                  |                                                  |
                                                  |                  |-----------|              |
                                                  |--------------|     C      |-----------|
                                                                       |-----------|

How about using the following basic formula instead?
2). D_opt(Ni, Y) < (D_opt(Ni, S) + D_opt(S, Y))

Advantages:
·         The formula two ensures that the packet does not loopback to S.
·         Also as per my understanding, if there is Neighbor Ni that satisfies 1), but does not satisfy 2), it implies that there is definitely one more Neigbhro Nj which satisfies 1) both 1) and 2).
(Because if there is a neighbor satisfying 1) and not satisfy 2), then the packet will loopback via some other neighbor which satisfies 2)).

Given that formula 2) ensures that we don't select any neighbor which simply loopbacks the packet to the source and forwards via other viable Neighbor, it will be more advantageous to employ Formula 2).

Please let me know if I am missing something, or if there is a good use case that may prefer backup-neighbor A2 in this example, over backup neighbor A1.(Given that traffic will exit via A1 anyway).

Thanks and Regards,
Bharath R.

--

For corporate legal information go to:

http://www.cisco.com/web/about/doing_business/legal/cri/index.html

--

For corporate legal information go to:

http://www.cisco.com/web/about/doing_business/legal/cri/index.html

--

For corporate legal information go to:

http://www.cisco.com/web/about/doing_business/legal/cri/index.html